package inference

import (
	"context"
	"errors"
	"github.com/zeromicro/go-zero/core/logx"
	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/scheduler/service/updater"
	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/svc"
	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/types"
	"strconv"
)

type StartDeployInstanceListLogic struct {
	logx.Logger
	ctx    context.Context
	svcCtx *svc.ServiceContext
}

func NewStartDeployInstanceListLogic(ctx context.Context, svcCtx *svc.ServiceContext) *StartDeployInstanceListLogic {
	return &StartDeployInstanceListLogic{
		Logger: logx.WithContext(ctx),
		ctx:    ctx,
		svcCtx: svcCtx,
	}
}

func (l *StartDeployInstanceListLogic) StartDeployInstanceList(req *types.StartDeployInstanceReq) (resp *types.StartDeployInstanceResp, err error) {
	resp = &types.StartDeployInstanceResp{}

	id, err := strconv.ParseInt(req.Id, 10, 64)
	ins, err := l.svcCtx.Scheduler.AiStorages.GetInferDeployInstanceById(id)
	if err != nil {
		return nil, err
	}

	l.svcCtx.Scheduler.AiStorages.UpdateInferDeployInstance(ins)

	success := l.svcCtx.Scheduler.AiService.InferenceAdapterMap[req.AdapterId][req.ClusterId].StartInferDeployInstance(l.ctx, req.InstanceId)
	if !success {
		return nil, errors.New("start instance failed")
	}

	go updater.UpdateDeployInstanceStatus(l.svcCtx, ins)

	return resp, nil
}
